-module(glychee@benchmark).
-compile(no_auto_import).

-export([run/2]).
-export_type([function_/2, data/1]).

-type function_(I, J) :: {function, binary(), fun((I) -> fun(() -> J))}.

-type data(K) :: {data, binary(), K}.

-spec run(list(function_(L, any())), list(data(L))) -> nil.
run(Function_list, Data_list) ->
    gleam_stdlib_each(
        Data_list,
        fun(Data) ->
            io:put_chars(<<"\n\n"/utf8>>),
            io:put_chars(
                <<"================================================================================"/utf8,
                  "\n"/utf8>>
            ),
            io:put_chars(
                <<<<"==== data set: "/utf8, (erlang:element(2, Data))/binary>>/binary,
                  " "/utf8>>
            ),
            io:put_chars(<<"\n"/utf8>>),
            io:put_chars(
                <<"================================================================================"/utf8,
                  "\n"/utf8>>
            ),
            io:put_chars(<<"\n"/utf8>>),
            _pipe = Function_list,
            _pipe@1 = lists:map(
                fun(Function) ->
                    {erlang:element(2, Function),
                     (erlang:element(3, Function))(erlang:element(3, Data))}
                end,
                _pipe
            ),
            'Elixir.GlycheeBenchee':run(_pipe@1)
        end
    ).

-spec gleam_stdlib_each(list(S), fun((S) -> any())) -> nil.
gleam_stdlib_each(List, F) ->
    case List of
        [] ->
            nil;

        [X | Xs] ->
            F(X),
            gleam_stdlib_each(Xs, F)
    end.
